{% include vue %}

<!-- Other dependencies -->
<link rel="stylesheet" href="https://unpkg.com/vue-easytable/libs/theme-default/index.css">
<script src="https://unpkg.com/vue-easytable/libs/umd/index.js"></script>
<script src="https://code.highcharts.com/stock/highstock.js"></script>

{% include data_explorer_html.html %}

<script>

    'use strict';

    var app = new Vue({
        el: "#app",
        data: {
            currentState: 'alabama',

            // The data is populated via loadData() method
            // on pageload and when changing the state.
            // It remains here in raw form as it comes from NYT.
            // Other computed methods and regular methods
            // transform this in ways appropriate for display.
            electionData: null, 

            states: {
                {% for state in site.data.states %}
                '{{ state[0] }}': {name: '{{ state[1].name }}', abbr: '{{ state[1].abbr }}'},
                {% endfor %}
            },

            /*columns: [
                {
                    field: "name",
                    key: "a",
                    title: "Name",
                    align: "center",
                },
            ],
            tableData: [
                {
                    name: "John",
                    date: "1900-05-20",
                    hobby: "coding and coding repeat",
                    address: "No.1 Century Avenue, Shanghai",
                },
            ],*/
           
        },
        computed: {
            currentStateName: function() {
                return this.states[this.currentState].name;
            },
            currentStateAbbr: function() {
                return this.states[this.currentState].abbr;
            },
            president: function() {
                var data = this.electionData.data.races.find(i => i.race_type == 'president');
                return data;
            },
            secondaryBallotRaces: function() {
                return this.electionData.data.races
                    .filter(race => race.votes > 0)
                    .sort((a,b) => a.votes < b.votes)
                    .map(race => {
                        race.leader_party_id = race.candidates[0] && race.candidates[0].party_id,
                        race.vote_percent = race.candidates[0] && (race.candidates[0].votes / race.votes * 100).round(2) + '%';
                        race.total_votes = race.votes.niceFormat();
                        race.candidate_count = race.candidates.length;
                        race.winning_margin = race.candidates[1] ?
                            ((race.candidates[0].percent - race.candidates[1].percent).round(2) + '%')
                            : '';
                        return race;
                    });
            }
        },
        watch: {
            /**
             * Whenever the currentState is changed:
             */
            currentState() {
                this.electionData = null;
                this.loadData();
            }
        },
        methods: {
            /**
             * Fetches the JSON data from NYT
             */
            loadData: function() {
                fetch('https://static01.nyt.com/elections-assets/2020/data/api/2020-11-03/state-page/' + this.currentState + '.json', {cache: 'force-cache'})
                    .then(response => response.json())
                    .then(json => {
                        // Store our data
                        app.electionData = json;
                        // Wait for DOM to update, and then activate time-series chart
                        Vue.nextTick(this.createTimeseriesChart);
                    })
                    .catch(err => app.error = 'The NYT could not be loaded. Post a comment on Telegram if this persists: https://t.me/ElectionFraud20_org')
            },

            /**
             * Creates the HighCharts graph of time-series data
             * Based on excellent work by William.
             */
            createTimeseriesChart: function(data) {

                var timeSeries = [];
                var seriesTitle = ""
                var seriesOptions = [
					{data:[], name:"Total Votes", color:'#00ff00' ,yAxis:1}, 
  					{data:[], name:"Ratio of Trump votes", color:'#ff0000', yAxis:0}, 
					{data:[], name:"Ratio of Biden votes", color:'#0000ff', yAxis:0},
                    {data:[], name:"eevp", color:'#000000', yAxis:0}
                ];

                //console.log('Starting appendData()');
                //let timeSeries = [];
                timeSeries = this.electionData.data.races[0].timeseries;
                
                timeSeries.sort(function(a,b){return new Date(a.timestamp) - new Date(b.timestamp);});
                
                seriesOptions[0].data = [];
                seriesOptions[1].data = [];
                seriesOptions[2].data = [];
                seriesOptions[3].data = [];
    
                timeSeries.forEach(tsData => {            
                    let date = new Date(tsData.timestamp).getTime();
                    
                    seriesOptions[0].data.push([date, tsData.votes]);
                    seriesOptions[1].data.push([date, tsData.vote_shares.trumpd]);
                    seriesOptions[2].data.push([date, tsData.vote_shares.bidenj]);
                    seriesOptions[3].data.push([date, tsData.eevp/100]);
                });
        
                seriesTitle = this.electionData.data.races[0].state_slug.toUpperCase();
                // console.log(seriesTitle);
    
                Highcharts.stockChart('ChartContainer', {
                        
                    chart: {type:'line', zoomType:'x',},
                    
                    rangeSelector: {
                        selected: 4,
                        buttons: [
                            {type:'hour', count:1, text:'Hour'},
                            {type:'day', count:1, text:'Day'},
                            {type:'week', count:1, text:'Week'},
                            {type:'all', text:'All'}
                        ],
                        enabled:true,
                        buttonTheme:{width:60}
                    },
                    
                    title: {text:seriesTitle},
                    
                    navigator: {enabled:true},
                    
                    credits: {enabled:false},
                    
                    yAxis: [{	
                        tickInterval: 0.10,
                        tickAmount: 11,
                        min:0, 
                        max: 1,
                        showLastLabel: true,
                        opposite: false,
                        lineWidth: 1,
                        alignTicks: false,
                        title:{text: 'Ratio'},
                    },{
                        showLastLabel: true,
                        opposite: true,
                        lineWidth: 1,
                        title:{text:'Total Votes'},
                    }],
                        
                    xAxis:{type:'datetime', showLastLabel:true, showFirstLabel:true},

                    series: seriesOptions,
                    
                    tooltip:{enabled:true, valueDecimals:2}			
                });
            },

            // Possibly applies to state level data only?
            calculateTimeseriesData: function(array, index, totalVotes) {
                var entry = array[index];

                // Some values are already present in the entry:
                //   entry.votes
                //   entry.vote_shares.trumpd
                //   entry.vote_shares.bidenj
                //   entry.eevp_source

                // We'll set some additional ones, below:
                //   entry.vote_shares.other
                //   entry.cum_trump_votes_min
                //   entry.cum_trump_votes_max
                //   entry.cum_biden_votes_min
                //   entry.cum_biden_votes_max
                //   entry.cum_other_votes_min
                //   entry.cum_other_votes_max

                // entry.percent_reporting = entry.votes / totalVotes;
                // entry.percent_reporting = entry.eevp; // (percent_reporting)

                // Cumulative Other % (calculated)
                entry.vote_shares.other = (1 - entry.vote_shares.trumpd - entry.vote_shares.bidenj).round(12);
                // Cumulative Trump Votes (average)
                entry.cum_trump_votes_avg = Math.round(entry.votes * entry.vote_shares.trumpd);
                // Cumulative Trump Votes (minimum)
                entry.cum_trump_votes_min = Math.ceil(entry.votes * (entry.vote_shares.trumpd - 0.0005));
                // Cumulative Trump Votes (maximum)
                entry.cum_trump_votes_max = Math.floor(entry.votes * (entry.vote_shares.trumpd + 0.000499999));
                // Cumulative Biden Votes (average)
                entry.cum_biden_votes_avg = Math.round(entry.votes * entry.vote_shares.bidenj);
                // Cumulative Biden Votes (minimum)
                entry.cum_biden_votes_min = Math.ceil(entry.votes * (entry.vote_shares.bidenj - 0.0005));
                // Cumulative Biden Votes (maximum)
                entry.cum_biden_votes_max = Math.floor(entry.votes * (entry.vote_shares.bidenj + 0.000499999));
                // Cumulative Other Votes (average)
                entry.cum_other_votes_avg = Math.round(entry.votes * entry.vote_shares.other);
                // Cumulative Other Votes (minimum)
                entry.cum_other_votes_min = Math.ceil(entry.votes * (entry.vote_shares.other - 0.0005));
                // Cumulative Other Votes (maximum)
                entry.cum_other_votes_max = Math.floor(entry.votes * (entry.vote_shares.other + 0.000499999));
                // Total Vote Increase
                entry.vote_increase = index == 0 ? entry.votes : (entry.votes - array[index-1].votes);
                // Trump Vote Increase (average)
                entry.trump_vote_increase_avg = index == 0 ? entry.cum_trump_votes_avg : (entry.cum_trump_votes_avg - array[index-1].cum_trump_votes_avg)
                // Trump Vote Increase (minimum)
                entry.trump_vote_increase_min = index == 0 ? entry.cum_trump_votes_min : (entry.cum_trump_votes_min - array[index-1].cum_trump_votes_max)
                // Trump Vote Increase (maximum)
                entry.trump_vote_increase_max = index == 0 ? entry.cum_trump_votes_max : (entry.cum_trump_votes_max - array[index-1].cum_trump_votes_min)
                // Biden Vote Increase (average)
                entry.biden_vote_increase_avg = index == 0 ? entry.cum_biden_votes_avg : (entry.cum_biden_votes_avg - array[index-1].cum_biden_votes_avg)
                // Biden Vote Increase (minimum)
                entry.biden_vote_increase_min = index == 0 ? entry.cum_biden_votes_min : (entry.cum_biden_votes_min - array[index-1].cum_biden_votes_max)
                // Biden Vote Increase (maximum)
                entry.biden_vote_increase_max = index == 0 ? entry.cum_biden_votes_max : (entry.cum_biden_votes_max - array[index-1].cum_biden_votes_min)
                // Other Vote Increase (average)
                entry.other_vote_increase_avg = index == 0 ? entry.cum_other_votes_avg : (entry.cum_other_votes_avg - array[index-1].cum_other_votes_avg)
                // Other Vote Increase (minimum)
                entry.other_vote_increase_min = index == 0 ? entry.cum_other_votes_min : (entry.cum_other_votes_min - array[index-1].cum_other_votes_max)
                // Other Vote Increase (maximum)
                entry.other_vote_increase_max = index == 0 ? entry.cum_other_votes_max : (entry.cum_other_votes_max - array[index-1].cum_other_votes_min)
                // % for Trump (average)
                entry.trump_percent_avg = entry.vote_increase == 0 ? 0 : entry.trump_vote_increase_avg / entry.vote_increase;
                // % for Trump (minimum)
                entry.trump_percent_min = entry.vote_increase == 0 ? 0 : entry.trump_vote_increase_min / entry.vote_increase;
                // % for Trump (maximum)
                entry.trump_percent_max = entry.vote_increase == 0 ? 0 : entry.trump_vote_increase_max / entry.vote_increase;
                // % for Biden (average)
                entry.biden_percent_avg = entry.vote_increase == 0 ? 0 : entry.biden_vote_increase_avg / entry.vote_increase;
                // % for Biden (minimum)
                entry.biden_percent_min = entry.vote_increase == 0 ? 0 : entry.biden_vote_increase_min / entry.vote_increase;
                // % for Biden (maximum)
                entry.biden_percent_max = entry.vote_increase == 0 ? 0 : entry.biden_vote_increase_max / entry.vote_increase;
                // % for Other (average)
                entry.other_percent_avg = entry.vote_increase == 0 ? 0 : entry.other_vote_increase_avg / entry.vote_increase;
                // % for Other (minimum)
                entry.other_percent_min = entry.vote_increase == 0 ? 0 : entry.other_vote_increase_min / entry.vote_increase;
                // % for Other (maximum)
                entry.other_percent_max = entry.vote_increase == 0 ? 0 : entry.other_vote_increase_max / entry.vote_increase;

                return entry;
            },

            /**
             * Generates the CSV data and sends the output to the browser
             * 
             * Parameters:
             * type can be 'presidential' or 'precinct'
             * raw can be 'raw' or 'enhanced'
             */
            csvExport: function(type, rawOrEnhanced) {
                var json;
                var totalVotes;

                if (type == 'presidential') {
                    json = this.president.timeseries;
                    totalVotes = this.president.votes;
                }

                // Sort by date
                json.sort((a,b) => a.timestamp > b.timestamp);

                // Column headings
                var csvHeadings = [
                    'State',
                    'Timestamp', 
                    'Date',
                    'Zulu (London) Time',
                    'eevp_source',
                    'Cumulative Votes', 
                    'Percent Reporting',
                    'Cumulative Trump % (inexact)', 
                    'Cumulative Biden % (inexact)', 
                ];

                // Additional headings shown in enhanced version
                if (rawOrEnhanced == 'enhanced') {
                    csvHeadings.push(
                        'Cumulative Other % (inexact)',
                        'Cumulative Trump Votes (approx)',
                        // 'Cumulative Trump Votes (min estimate)',
                        // 'Cumulative Trump Votes (max estimate)',
                        'Cumulative Biden Votes (approx)', 
                        // 'Cumulative Biden Votes (min estimate)', 
                        // 'Cumulative Biden Votes (max estimate)', 
                        'Cumulative Other Votes (approx)',
                        // 'Cumulative Other Votes (min estimate)',
                        // 'Cumulative Other Votes (max estimate)',
                        'Total Vote Increase',
                        'Trump Vote Increase (approx)',
                        // 'Trump Vote Increase (min estimate)',
                        // 'Trump Vote Increase (max estimate)',
                        'Biden Vote Increase (approx)', 
                        // 'Biden Vote Increase (min estimate)', 
                        // 'Biden Vote Increase (max estimate)', 
                        'Other Vote Increase (approx)',
                        // 'Other Vote Increase (min estimate)',
                        // 'Other Vote Increase (max estimate)',
                        '% for Trump (approx)',
                        // '% for Trump (min estimate)',
                        // '% for Trump (max estimate)',
                        '% for Biden (approx)',
                        // '% for Biden (min estimate)',
                        // '% for Biden (max estimate)',
                        '% for Other (approx)'
                        // '% for Other (min estimate)',
                        // '% for Other (max estimate)',
                    );
                }
                
                var csv = json.map((entry, i) => {
                    // console.log('Parsing', i);

                    if (rawOrEnhanced == 'enhanced')
                        entry = this.calculateTimeseriesData(json, i, totalVotes);

                    // These columns must be in the exact same order as column headings above
                    // otherwise data won't match
                    var result = [
                        this.currentStateName,
                        entry.timestamp,
                        extractDate(entry.timestamp), // Date only
                        extractTime(entry.timestamp), // Time only
                        entry.eevp_source,
                        entry.votes,
                        entry.eevp, // this is "percent reporting"
                        entry.vote_shares.trumpd,
                        entry.vote_shares.bidenj
                    ];

                    if (rawOrEnhanced == 'enhanced') {
                        result = result.concat([
                            entry.vote_shares.other,
                            entry.cum_trump_votes_avg,
                            // entry.cum_trump_votes_min,
                            // entry.cum_trump_votes_max,
                            entry.cum_biden_votes_avg,
                            // entry.cum_biden_votes_min,
                            // entry.cum_biden_votes_max,
                            entry.cum_other_votes_avg,
                            // entry.cum_other_votes_min,
                            // entry.cum_other_votes_max,
                            entry.vote_increase,
                            entry.trump_vote_increase_avg,
                            // entry.trump_vote_increase_min,
                            // entry.trump_vote_increase_max,
                            entry.biden_vote_increase_avg,
                            // entry.biden_vote_increase_min,
                            // entry.biden_vote_increase_max,
                            entry.other_vote_increase_avg,
                            // entry.other_vote_increase_min,
                            // entry.other_vote_increase_max,
                            entry.trump_percent_avg,
                            // entry.trump_percent_min,
                            // entry.trump_percent_max,
                            entry.biden_percent_avg,
                            // entry.biden_percent_min,
                            // entry.biden_percent_max,
                            entry.other_percent_avg,
                            // entry.other_percent_min,
                            // entry.other_percent_max,
                        ]);
                    }
                    return result;
                });

                // Prepend headings row into final data
                csv.unshift(csvHeadings);

                this.sendCsvToBrowser(csv, rawOrEnhanced);
            },

            precinctCsvExport: async function() {
                // Fetch the data
                var data = await this.fetchPrecinctData();

                // console.log(data);

                if (!data.precincts) {
                    alert('Oops. The data was not in the format we were expecting. Unfortuantely the CSV cannot be exported.')
                    return;
                }

                // Convert to appropriate structure
                // data = this.parsePrecinctData(data);
                data.precincts.forEach(p => {
                    // console.log(p);
                    for (var key in p.results) {
                        p['results.' + key] = p.results[key];
                    }
                    delete p.results;
                });

                // Headings
                var colHeadings = []; //Object.keys(data.precincts[0]);

                // Data
                data = data.precincts.map(row => {
                    var result = [];

                    // Loop through all keys in the current precinct
                    for (var key in row) {
                        var columnIndex = colHeadings.indexOf(key);

                        // If it's not already in the headings list, add it
                        if (columnIndex == -1) {
                            colHeadings.push(key);
                            columnIndex = colHeadings.length - 1;
                        }

                        // Then add in the data to the correct column
                        result[columnIndex] = row[key];
                    }

                    return result;
                });

                data = [colHeadings].concat(data);

                // For debugging:
                // console.log(data);
                
                this.sendCsvToBrowser(data, 'precincts');
            },

            fetchPrecinctData: function() {
                return fetch('https://static01.nyt.com/elections-assets/2020/data/api/2020-11-03/precincts/' + this.currentStateAbbr + 'General-latest.json')
                    .then(response => {
                        if (!response.ok)
                            throw new Error(response.status + ' ' + response.statusText);
                        return response;
                    })
                    .then(response => response.json())
                    .catch(error => {
                        alert('Oops! We could not load the precinct JSON data. Some states appear to be missing from the NYT data for some unknown reason. Try loading the raw JSON data directly. If this persists, let us know via Telegram or by commenting below.\n\nError: ' + error.message);
                    });
            },

            parsePrecinctData: function(rawData) {
                var result = rawData;
                return result;
            },

            /**
             * Pass in a 2-dimensional array of rows and columns
             * This function will convert to a string
             * and ask the browser to save the resulting file
             */
            sendCsvToBrowser: function(csv, suffix) {

                // Convert to string by adding tabs and newlines
                csv = csv.map(row => row.join('\t')).join('\n');
                
                // FOR DEBUGGING ONLY
                // Log to console and exit
                // console.log(csv); return;

                // Convert to data URI
                csv = encodeURI('data:text/csv;charset=utf-8,' + csv);

                // Doing this leaves no file extension in Chrome:
                // window.open(csv);

                // Download file
                var link = document.createElement("a");
                link.setAttribute("href", csv);
                link.setAttribute("download", 
                    this.currentState + "_2020_election_data_" + suffix + ".csv"
                );
                document.body.appendChild(link); // Required for FF
                link.click(); // This will download the data file named "my_data.csv".
                
            }
        }
    });

    app.loadData();

    // Returns just the date portion from a timestamp string
    function extractDate(timestamp) {
        timestamp = timestamp.split(/[TZ]/);
        return timestamp[0];
    }
    // Returns just the date portion from a timestamp string
    function extractTime(timestamp) {
        timestamp = timestamp.split(/[TZ]/);
        return timestamp[1] ? timestamp[1] : timestamp[0];
    }

</script>

<style>
    .ve-table table.ve-table-content thead.ve-table-header tr.ve-table-header-tr th.ve-table-header-th,
    .ve-table table.ve-table-content tbody.ve-table-body tr.ve-table-body-tr td.ve-table-body-td, .ve-table table.ve-table-content tbody.ve-table-body tr.ve-table-expand-tr td.ve-table-body-td, .ve-table table.ve-table-content tbody.ve-table-body tr.ve-table-body-tr td.ve-table-expand-td, .ve-table table.ve-table-content tbody.ve-table-body tr.ve-table-expand-tr td.ve-table-expand-td {
        font-size: 85%;
    }

    .post-title, .post-header { margin-bottom: 8px }

</style>